import typing

from pydantic import BaseModel, model_validator
from qiskit import ClassicalRegister, QuantumCircuit, QuantumRegister


class Motherboard(BaseModel):
    quantum_registers: typing.Any | None
    classical_registers: typing.Any | None
    circuit: typing.Any | None

    @model_validator(mode="before")
    @classmethod
    def _initialize_system(cls, values: typing.Dict) -> typing.Dict:
        values["quantum_registers"] = QuantumRegister(3)
        values["classical_registers"] = ClassicalRegister(2)
        values["circuit"] = QuantumCircuit(
            values["quantum_registers"], values["classical_registers"]
        )
        return values
